/*---------------------------------------------------------------------------------
	main.c - thmp3 player example/demonstration app
		Kallisti (K) eris 2008-07-18 All rights reversed. 
	        http://blea.ch/wiki/
---------------------------------------------------------------------------------*/
#include "nds.h"
#include <nds/arm9/console.h> //basic print funcionality
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include "nitrofs.h" //only needed in the file where nitroFSInit() function is called.
#include <fat.h>
#include "thds_8x8grid_raw.h"	//the font
#include "rickhead_raw.h"
#include "rickchart_raw.h"
#include "ricktitle_raw.h"
#include <thfifo.h>
#include <thmp3.h>
#include <thsound.h>
#include <thbg.h>
#include "powerctl9.h"                   // Include PowerControler's header on ARM9

#include "nitrofsadv.h"	//quicker startup

//ARM9!!

FILE *MP3Stream;

#define VSYNC(x)   do {int z;                                      \
                       for (z=0; z<(x); z++) swiWaitForVBlank();   \
                   } while(0)

#define FILENAME "rickroll.nds"

//this function will be called each time song changed ^^
void myMp3PlayCallback(char *filename, char *title) {
	iprintf("\x1b[23;0Hnp:%s      ",title);
}

#define MAXFRAMES 342
#define FRAMERATE 10
#define FRAMEDIV (60/FRAMERATE)
//#define FRAMEDIV 3	//uhhh, this rly isnt right, 4 is what i calculated however i think it is perhaps missing a frame
			//however 3 syncs okai, so whatever! :P

int vbcnt;
int fps;
int fpscnt;
KEYPAD_BITS keysheld;
static KEYPAD_BITS keyslast=0;	//hmpf... scanKeys 

int frmcnt;

thSample_t *mysamp;

void vBlankInt(void) {
	if(((vbcnt%((MAXFRAMES/FRAMERATE)*60) )==0)&&(mysamp)) {
		thSndStop(10);
		thSndStop(11);
		thSndPlaySample(10, mysamp, 127, 0);
		thSndPlaySample(11, mysamp, 127, 127);
		vbcnt=0;
	}
	vbcnt++;
	if((vbcnt%60)==0) {
		fps=fpscnt;
		fpscnt=0;
	}
	scanKeys();                           	// Scan Key now in V-Blank handler
	keysheld=keysHeld();			//just get the values
}

//Custom keysDown function is required due to libnds updating keysDown 
KEYPAD_BITS myKeysDown(void) {
	KEYPAD_BITS retval;
	retval=(keysheld&~keyslast);
	keyslast=keysheld;
	return(retval);
}

//Check if lid is down and if so sleepz z_zZzZzZZZ :P
void checkLID(void) {
   if (!(keysheld & KEY_LID)) return;               // LID is opened.

   // Enter Low Power mode

//   bgm9chmask(0xffff);                         // If BGMDRV is used.
   VSYNC(8);                                   // wait 100(msec)

   power9off(POW_LCD1 | POW_LCD2);
   power9off(POW_ENGINE_A | POW_ENGINE_B);
   power9off(POW_SPEAKER | POW_SOUND_AMP);

   // VSYNC Loop during LID is closed.

   while (1) {                                 // This loop usually exits in 1st time.
       power9sleep();                          // Enter SLEEP mode
                                               // until LID is opened.
       VSYNC(10);
       if ((keysheld & KEY_LID) == 0)   break;      // LID is opened.
   }

   // Exit Low Power mode

   VSYNC(10);                                  // wait 166 (msec)
   power9on(POW_SPEAKER | POW_SOUND_AMP);
   power9on(POW_ENGINE_A | POW_LCD2);
   power9on(POW_ENGINE_B | POW_LCD1);

//   bgm9chmask(0);                              // If BGMDRV is used.

   // Exit This function
}

int tframecnt;

void updateVid(int frame) {
	char filename[0x100];
	if((frame%FRAMEDIV)==0) { //get us @ 15fps
		sprintf(filename,"nitro:/rickrollframes/rick%d.raw",(frame/FRAMEDIV)%MAXFRAMES);
		fpscnt++;
		tframecnt++;
		FILE *f=fopen(filename,"rb");
		if(f) {
			fread((void*)BGBMPRAM(1,2)+(sizeof(u16)*256*32),sizeof(u16),49152,f);
			fclose(f);
		} else {

			thBgBlitTile(1,0,thds_8x8grid_raw,thds_8x8grid_raw_size);
			printf("opening %s failed, frame %d\n",filename,tframecnt);
			printf("I sleepz nao zZzzzZZ...\n");
			while(1) {
				swiWaitForVBlank();
			};
		}
	}
}


//---------------------------------------------------------------------------------
int main(int argc, char ** argv) {
//---------------------------------------------------------------------------------
	int credits;
	int mp3mode;
	int rotangle, zoom, scrollx, scrolly, xc, yc;
 	irqInit();
        irqSet(IRQ_VBLANK, NULL);
        irqEnable(IRQ_VBLANK);
	powerON(POWER_ALL);
	videoSetModeSub(MODE_0_2D|DISPLAY_SPR_ACTIVE|DISPLAY_BG0_ACTIVE|DISPLAY_SPR_1D|DISPLAY_SPR_EXT_PALETTE|DISPLAY_SPR_1D_BMP|DISPLAY_BG_EXT_PALETTE|DISPLAY_SPR_1D_SIZE_128);	//sub bg 0 will be used to print text
	videoSetMode(MODE_0_2D|DISPLAY_SPR_ACTIVE|DISPLAY_BG0_ACTIVE|DISPLAY_SPR_1D|DISPLAY_SPR_EXT_PALETTE|DISPLAY_SPR_1D_BMP|DISPLAY_BG_EXT_PALETTE|DISPLAY_SPR_1D_SIZE_128);
	thBgInit();
	setBgVBlank();
	/******************
	* Setup a custom font, allocing vram via thbglib
	*******************/
	//alloc vram for console/text on both screens plz, also copy 
	thBgCreate(0, 0, BG_32x32 | BG_16_COLOR | BG_PRIORITY(BG_PRIORITY_0), (u16*)thds_8x8grid_raw, thds_8x8grid_raw_size, NULL, 1024);
	thBgCreate(1, 0, BG_32x32 | BG_16_COLOR | BG_PRIORITY(BG_PRIORITY_0), (u16*)thds_8x8grid_raw, thds_8x8grid_raw_size, NULL, 1024);
	consoleInit((u16*)thds_8x8grid_raw, (u16*)CHAR_BASE_BLOCK_SUB(thBgTile(0,0)), 192, 0, (u16*)SCREEN_BASE_BLOCK_SUB(thBgMap(0,0)), 15, 16);
	//Set font colors
	BG_PALETTE_SUB[243] = RGB15(0,31,0);	//by default font will be rendered with color 255
	BG_PALETTE[243] = RGB15(0,31,0);	//by default font will be rendered with color 255
	BG_PALETTE[241] = RGB15(0,0,0);	//BG COLOR? black
	BG_PALETTE_SUB[241] = RGB15(0,0,0);	//BG COLOR? black
        BG_PALETTE[0]=RGB15(0,0,0);
	mysamp=NULL;
	thBgSetVBlank(&vBlankInt);
/*
	//Left this in, its essentiall what the thBgCreateBmp thingy does
	thBgSetMode(MODE_5_2D);
	thBgCreateAlloc(0, 2, 98304, 0);
	thBgSetRotScale(0, 2, 0, 256, 256, 0, 0, 0, 0);
	BGCR(0,2)=BG_BMP16_256x256|BG_MAP_BASE(thbgs[0][2].map)|BG_PRIORITY(BG_PRIORITY_1)|BG_WRAP_ON;
	thBgEnable(0,2);

	thBgSetModeSub(MODE_5_2D);
	thBgCreateAlloc(1, 2, 98304, 0);
	thBgSetRotScale(1, 2, 0, 256, 256, 0, 0, 0, 0);
	BGCR(1,2)=BG_BMP16_256x256|BG_MAP_BASE(thbgs[1][2].map)|BG_PRIORITY(BG_PRIORITY_1)|BG_WRAP_ON;
	thBgEnable(1,2);
	thBgBlitBmp(1,2,rickhead_raw,rickhead_raw_size);
	thBgBlitBmp(0,2,ricktitle_raw,ricktitle_raw_size);
*/
	thBgSetMode(MODE_5_2D);
	thBgCreateBmp(0, 2, BG_BMP16_256x256, (u16*)ricktitle_raw, ricktitle_raw_size);
	thBgSetModeSub(MODE_5_2D);
	thBgCreateBmp(1, 2, BG_BMP16_256x256, (u16*)rickhead_raw, rickhead_raw_size);
	iprintf("\x1b[0;0H");
	fifoInit();
//	printf("Initalizing mp3player and audio\n");
	mp3Init();
	thSndInit();
	power9init();                         // Initialize POWERCTL9
	vbcnt=0;
//	printf("initalizing nitrofs\n");
	if(nitroFSInitAdv(FILENAME)) {
		credits=3;
		mp3mode=0;
		rotangle=0;
		zoom=256;
		xc=0;
		yc=0;
		scrollx=0;
		scrolly=0;
		//nitro filesystem opened successfully!!
		mp3SetOpts(MP3_ADVANCE|MP3_REPEAT);
		mp3SetPlayCb(&myMp3PlayCallback);
		//mp3PlaylistAddM3u("nitro:/playlist.m3u");	//add m3u playlist
		//iprintf("%d songs loaded\n",mp3GetPlaylistCnt());
		mysamp=thSampleLoadWav("nitro:/rickrolladpcm.wav");
		if(mysamp==0) {
			printf("loading wave failed\n");
		} else {
			iprintf("\x1b[2J");		//clear screen
		}
		while(vbcnt<(60*2)) {
			swiWaitForVBlank();
		};
		iprintf("\x1b[2J"); //clear screen
		iprintf("\x1b[23;25Hfps:%02d",0);
		swiWaitForVBlank();
		vbcnt=0;
		fps=0;
		tframecnt=0;
		BG_PALETTE_SUB[243] = RGB15(31,31,31);	//by default font will be rendered with color 255
		BG_PALETTE[243] = RGB15(31,31,31);	//by default font will be rendered with color 255
		bzero16((u16 *)BGCTILERAM(1,0), 256*256*sizeof(u16));
		thBgBlitBmp(0,2,rickhead_raw,rickhead_raw_size);
		while(1) {
			KEYPAD_BITS keys=myKeysDown();
			if(keys&KEY_A) {	//start playing mp3s instead of nyan nyan .wav
				if(mp3mode==0) {
					thBgBlitBmp(0,2,ricktitle_raw,ricktitle_raw_size);
					mp3mode=1;
				} else if (mp3mode==1){
					thBgBlitBmp(0,2,rickchart_raw,rickchart_raw_size);
					mp3mode=2;
				} else if(mp3mode==2) {
					thBgBlitBmp(0,2,rickhead_raw,rickhead_raw_size);
					mp3mode=0;
				}
			}
			if(keys&KEY_START) {	//restart loop and stop mp3mode
  				vbcnt=0;
				mp3mode=0;
				rotangle=0;
				zoom=256;
				xc=0;
				yc=0;
				scrollx=0;
				scrolly=0;
				iprintf("\x1b[2J");		//clear screen
			}
			if(keys&KEY_SELECT) {	//show credits
				credits++;
				credits=credits%4;
				if(credits==1) {
					iprintf("\x1b[0;6HRickroll Player v0.1");
					iprintf("\x1b[2;7Hhttp://blea.ch/wiki/\n");
					iprintf("\x1b[7;8HKEYS:\n");
					iprintf("\x1b[8;9HStart = Reset\n");
					iprintf("\x1b[9;9HSelect = this\n");
					iprintf("\x1b[10;9HL/R Shoulder = rotate\n");
					iprintf("\x1b[11;9HX/Y = zoom\n");
					iprintf("\x1b[12;9HA = mp3 mode\n");
					iprintf("\x1b[13;9HDPad = scroll\n");
					iprintf("\x1b[14;9HB+DPAD = center\n");
				} else if(credits==2) {
					iprintf("\x1b[2J");		//clear screen
				} else if(credits==3) { //erase font
					bzero16((u16 *)BGTILERAM(1,2), 256*256*sizeof(u16));
				} else {
					//this just to reload font
					thBgBlitTile(1,0,thds_8x8grid_raw,thds_8x8grid_raw_size);
					iprintf("\x1b[2J");		//clear screen
				}
			}
			if(keysheld&KEY_L) {
				rotangle--;
			} else if(keysheld&KEY_R) {
				rotangle++;
			}
			if(keysheld&KEY_B) {
				if(keysheld&KEY_LEFT) {
					xc--;
				} else if(keysheld&KEY_RIGHT) {
					xc++;
				} else if(keysheld&KEY_UP) {
					yc--;
				} else if(keysheld&KEY_DOWN) {
					yc++;
				}
			} else {
				if(keysheld&KEY_LEFT) {
					scrollx++;
				} else if(keysheld&KEY_RIGHT) {
					scrollx--;
				} else if(keysheld&KEY_UP) {
					scrolly++;
				} else if(keysheld&KEY_DOWN) {
					scrolly--;
				}
			}
			if(keysheld&KEY_X) {
				zoom++;
			} else if(keysheld&KEY_Y) {
				zoom--;
			}
			thBgSetRotScale(1, 2, rotangle, zoom, zoom, scrollx, scrolly, xc, yc);
			if(credits==2) {
					iprintf("\x1b[19;3Hangle  =%5d    zoom=%5d",rotangle,zoom);
					iprintf("\x1b[20;3Hscrollx=%5d scrolly=%5d",scrollx,scrolly);
					iprintf("\x1b[21;3Hxcenter=%5d ycenter=%5d",xc,yc);
			}
			swiWaitForVBlank();
			updateVid(vbcnt);
			mp3Update();
			if(credits!=3) {
				printf("\x1b[23;25Hfps:%02d",fps);
			}
			checkLID();                               // Check state of NDS lid.
		}
	} else {
		//here if filesystem failed to start
		printf("Failed...\n");
		printf("Cannot open %s please check filename and path are correct.\n",FILENAME);
	}
	return 0;
}
